﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;

namespace Scraping._01.ScrapeIMDB
{
    class Program
    {
        static void Main(string[] args)
        {
            string movieName = null;
            while (movieName == null || movieName.ToLower() != "exit")
            {
                Console.WriteLine("Hello! I am the master of movie ratings. Enter the name of the movie and I'll tell you if you should watch it or not. Type exit to.. well... exit.");
                movieName = Console.ReadLine();
                if(!String.IsNullOrEmpty(movieName))
                    Console.WriteLine("{0} is rated {1} out of 10!", movieName, GetMovieRating(movieName));
            }
        }

        static Single GetMovieRating(string movieName)
        {
            var webClient = new System.Net.WebClient();
            string searchUrl = "http://www.imdb.com/find?s=all&q=" + HttpUtility.UrlEncode(movieName);
            string searchResponse = webClient.DownloadString(searchUrl);
            Match movieUrlMatch = Regex.Match(searchResponse, @"1\..*?href=""(?<MovieLink>[^""]*)""");
            if (!movieUrlMatch.Success) return 0.0f;
            string movieResponse = webClient.DownloadString("http://www.imdb.com" + movieUrlMatch.Groups["MovieLink"].Value);
            Match movieRatingMatch = Regex.Match(movieResponse, @"(?<Rating>\d\.\d)/10");
            Single movieRating;
            if (!movieRatingMatch.Success || !Single.TryParse(movieRatingMatch.Groups["Rating"].Value, out movieRating)) return 0.0f;
            return movieRating;
        }
    }
}
